#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
    int T,N,M,S;
    cin>>T;
    for(int i=0;i<T;i++){
        cin>>N>>M>>S;
        int cm=0;
        unordered_set<int> ros;
        for(int j=0;j<S;j++){
            int te;
            cin>>te;
            ros.insert(te);
        }
        //for(const auto& de:ros)cout<<de<<"f\n";
        unordered_map<int,unordered_set<int>> m;
        for(int j=0;j<M;j++){
            int a,b;
            cin>>a>>b;
            if(!(N!=2&&ros.count(a)&&ros.count(b))){
            m[a].insert(b);
            m[b].insert(a);
            cm++;
            }
        }
        //cout<<cm;
        if(cm<N-1){cout<<-1;
        continue;
        }
    }
}